/*
##################################################
DumaNet üzenőfal script by Adam
www.dumanet.hu
A script letöltése CSAK a dumanet.hu-ról javasolt!
public beta 1
##################################################
*/

on 1:start:uzenofal_init
on 1:load:{
  echo -a #########################################################
  echo -a DumaNet üzenőfal script $s_version betöltve
  echo -a Használd a /uzenofal parancsot az üzenőfal megnyitásához!
  echo -a A script letöltése CSAK a dumanet.hu-ról javasolt!
  echo -a #########################################################
  uzenofal_init
}
menu menubar {
  DumaNet üzenőfal:uzenofal
}
menu channel {
  DumaNet üzenőfal:uzenofal
}
menu status {
  DumaNet üzenőfal:uzenofal
}
on 1:unload:{
  if ($timer(dn_uzenofal)) .timerdn_uzenofal off
  if (%dumanet_uzenofal_beallitas) unset %dumanet_uzenofal_beallitas
  if (%dumanet_uzenofal_updatesocket) unset %dumanet_uzenofal_updatesocket
  if (%dumanet_uzenofal_last) unset %dumanet_uzenofal_last
  if (%dumanet_uzenofal_buffersocket) unset %dumanet_uzenofal_buffersocket
  if (%dumanet_uzenofal_checksocket) unset %dumanet_uzenofal_checksocket
  echo -a ####################################
  echo -a DumaNet üzenőfal script eltávolítva!
  echo -a ####################################
}
dialog dumanet_uzenofal_beallitas {
  title "DumaNet Üzenőfal - Beállítások"
  size -1 -1 308 211
  option pixels notheme
  check "Automatikus ellenőrzés bekapcsolása", 5, 2 4 201 17
  text "Frissítési intervallum:", 6, 16 25 102 17
  combo 7, 120 22 55 73, drop
  check "Ablak villogtatása új üzenet érkezésekor", 8, 16 43 211 17
  check "tip üzenet megjelenítése új üzeneteknél", 9, 16 61 291 17
  check "Üzenetküldés engedélyezése", 11, 3 108 169 17
  text "DumaNet felhasználónév:", 12, 18 130 124 17, right
  text "DumaNet jelszó:", 13, 42 149 100 17, right
  edit "", 14, 145 129 155 20
  edit "", 15, 145 148 155 20, pass
  button "Mentés", 16, 90 179 65 25, flat
  button "Mégse", 17, 157 179 65 25, cancel flat
  check "Üzenetértesítő az aktív ablakban", 19, 16 79 178 17
  text "perc", 1, 178 25 28 17
}
dialog dumanet_uzenofal {
  title "DumaNet - Üzenőfal"
  size -1 -1 252 328
  option pixels notheme
  edit "", 1, 2 2 250 300, read multi return vsbar
  button "Beállítások", 2, 101 303 81 25
  button "Új üzenet", 3, 3 303 65 25
  button "Frissítés", 4, 185 303 65 25
  button "c", 5, -59 -23 65 0, cancel
}
dialog dumanet_uzenofal_write {
  title "Üzenet a DumaNet falra"
  size -1 -1 400 71
  option pixels notheme
  edit "", 1, 2 20 394 20, autohs limit 300
  text "Üzenet:", 2, 2 3 100 17
  button "Mehet", 3, 330 42 65 25, flat
  text "300/300", 4, 4 48 100 17, disable
}
alias -l uzenofal_init {
  if (!%dumanet_uzenofal_beallitas) { varcheck | uzenofal }
  else {
    if ($svar(2)) .timerdn_uzenofal -o 0 $calc($svar(2) *60) uzenofal -new
  }
  uzenofal -init
}
alias -l varcheck {
  if (!%dumanet_uzenofal_beallitas) %dumanet_uzenofal_beallitas = 1×1×0×1×1×0
}
alias -l svar {
  return $gettok(%dumanet_uzenofal_beallitas,$1,215)
}
alias -l s_version {
  return 1.0
}
alias uzenofal {
  if ($1 == -s) {
    if (!$dialog(dumanet_uzenofal_beallitas)) dialog -m dumanet_uzenofal_beallitas dumanet_uzenofal_beallitas
  }
  if ($1 == -init) {
    if ($dialog(dumanet_uzenofal)) {
      did -r dumanet_uzenofal 1
    }
    .timer -m 1 100 uzenofal -buffer
  }
  if ($1 == -buffer) {
    var %socket dn_uzenofal_buffer $+ $rand(1,9999999)
    %dumanet_uzenofal_buffersocket = %socket
    sockopen %socket dumanet.hu 80
  }
  if ($1 == -new) {
    var %socket dn_uzenofal_check $+ $rand(1,9999999)
    %dumanet_uzenofal_checksocket = %socket
    sockopen %socket dumanet.hu 80
  }
  if ($1 == -send) {
    if (!$2) {
      if (!$dialog(dumanet_uzenofal_write)) dialog -m dumanet_uzenofal_write dumanet_uzenofal_write
      halt
    }
    if ($socket(dn_uzenofal_send)) || (!$2) halt
    %dumanet_uzenofal_msg = $replace($2-,$chr(32),$chr(37) $+ 20)
    sockopen dn_uzenofal_send dumanet.hu 80
  }
  if (!$1) {
    if ($dialog(dumanet_uzenofal)) dialog -c dumanet_uzenofal
    .timer -m 1 10 dialog -m dumanet_uzenofal dumanet_uzenofal
  }
}
on 1:dialog:dumanet_uzenofal_beallitas:*:*:{
  if ($devent == init) {
    varcheck
    if ($version < 6.31) did -a $dname 9 tip üzenet megjelenítése új üzeneteknél (mIRC 6.31+)
    if ($svar(1)) did -c $dname 5
    did -a $dname 7 1
    if ($svar(2) == 1) did -c $dname 7 1
    did -a $dname 7 5
    if ($svar(2) == 5) did -c $dname 7 2
    did -a $dname 7 10
    if ($svar(2) == 10) did -c $dname 7 3
    did -a $dname 7 20
    if ($svar(2) == 20) did -c $dname 7 4
    did -a $dname 7 30
    if ($svar(2) == 30) did -c $dname 7 5
    if ($svar(3)) did -c $dname 8
    if ($svar(4)) && ($version >= 6.31) did -c $dname 9
    if ($svar(5)) did -c $dname 19
    if ($svar(6)) did -c $dname 11
    if ($svar(7)) did -a $dname 14 $svar(7)
    if ($svar(8)) did -a $dname 15 $svar(8)
  }
  if ($devent == sclick) {
    if ($did == 16) {
      if ($did(11).state) {
        if (!$did(14)) { did -f $dname 14 | halt }
        if (!$did(15)) { did -f $dname 15 | halt }
      }
      %dumanet_uzenofal_beallitas = $did(5).state $+ × $+ $did(7) $+ × $+ $did(8).state $+ × $+ $did(9).state $+ × $+ $did(19).state $+ × $+ $did(11).state $+ × $+ $iif($did(14),$did(14),0) $+ × $+ $iif($did(15),$did(15),0)
      if ($did(5).state) {
        .timerdn_uzenofal -o 0 $calc($did(7) *60) uzenofal -new
      }
      else {
        if ($timer(dn_uzenofal)) .timerdn_uzenofal off
      }
      dialog -c $dname
    }
  }
  if ($devent == close) uzenofal
  if ($did(11).state) { did -e $dname 14 | did -e $dname 15 | did -e $dname 12 | did -e $dname 13 }
  else { did -b $dname 14 | did -b $dname 15 | did -b $dname 12 | did -b $dname 13 }
  if ($did(5).state) { did -e $dname 6 | did -e $dname 7 | did -e $dname 1 | did -e $dname 8 | did -e $dname 9 | did -e $dname 19 }
  else { did -b $dname 6 | did -b $dname 7 | did -b $dname 1 | did -b $dname 8 | did -b $dname 9 | did -b $dname 19 }
}
on 1:dialog:dumanet_uzenofal:*:*:{
  if ($devent == init) && ($did == 0) .timer -m 1 300 uzenofal -init
  if ($devent == sclick) {
    if ($did == 4) { uzenofal -init }
    if ($did == 2) { uzenofal -s | dialog -c $dname }
    if ($did == 3) { dialog -c $dname | uzenofal -send }
  }
}
on 1:dialog:dumanet_uzenofal_write:*:*:{
  if (!$svar(6)) {
    did -b $dname 1
    did -b $dname 3
    did -r $dname 1
    did -a $dname 1 A küldést nem engedélyezted az üzenőfal beállítáasinál!
  }
  else {
    did -r $dname 4
    did -a $dname 4 $calc(300 - $len($did(1)))
  } 
  if ($devent == sclick) && ($did == 3) {
    if ($len($did(3)) < 3) { echo -a Írj legalább 3 karaktert! | halt }
    uzenofal -send $did(1)
    dialog -c $dname
  }
  if ($devent == close) uzenofal
}
on 1:sockopen:dn_uzenofal_buffer*:{
  if ($sockerr > 0) { echo -a Nem sikerült csatlakozni: $sock($sockname).addr | sockclose $sockname | halt }
  sockwrite -n $sockname GET /messboard_mirc.php?ASC $+ $iif($version < 7,&noekezet) HTTP/1.1
  sockwrite -n $sockname Host: www.dumanet.hu
  sockwrite -n $sockname Connection: Keep-Alive
  sockwrite -n $sockname $crlf
}
on 1:sockopen:dn_uzenofal_check*:{
  if ($sockerr > 0) { echo -a Nem sikerült csatlakozni: $sock($sockname).addr | sockclose $sockname | halt }
  sockwrite -n $sockname GET /messboard_mirc.php?ASC&lastfrom= $+ %dumanet_uzenofal_last $+ $iif($version < 7,&noekezet) HTTP/1.1
  sockwrite -n $sockname Host: www.dumanet.hu
  sockwrite -n $sockname Connection: Keep-Alive
  sockwrite -n $sockname $crlf
}
on 1:sockopen:dn_uzenofal_send:{
  if ($sockerr > 0) { unset %dumanet_uzenofal_msg | echo -a Nem sikerült csatlakozni: $sock($sockname).addr | sockclose $sockname | halt }
  var %msg %dumanet_uzenofal_msg
  unset %dumanet_uzenofal_msg
  sockwrite -n $sockname GET /messboard_mirc.php?send&user= $+ $svar(7) $+ &pass= $+ $md5($svar(8)) $+ &msg= $+ $$iif($version < 7,$replace(%msg,á,a,é,e,í,i,ó,o,ö,o,ő,o,ú,u,ű,u,ü,u,Á,A,É,E,Í,I,Ó,O,Ö,O,Ő,O,Ú,U,Ü,U,Ű,U),%msg)  HTTP/1.1
  sockwrite -n $sockname Host: www.dumanet.hu
  sockwrite -n $sockname Connection: Keep-Alive
  sockwrite -n $sockname $crlf
}
on 1:sockread:dn_uzenofal_send:{
  if ($sockerr > 0) halt
  sockread %dumanet_send_tmp
  tokenize 32 %dumanet_send_tmp
  unset %dumanet_send_tmp
  if ($1 == return:) {
    if ($2 == E_LOGIN) echo -a Sikertelen küldés - hibás bejelentkezési adatok
    if ($2 == E_FLOOD) echo -a Sikertelen küldés - percenként csak 1 üzenetet küldhetsz!
    if ($2 == E_LEN) echo -a Sikertelen küldés - Csak a 3-300 karakter közötti üzenetek küldhetők el
    uzenofal
    sockclose $sockname
  }
}
on 1:sockread:dn_uzenofal_buffer*:{
  if ($sockerr > 0) halt
  if ($sockname != %dumanet_uzenofal_buffersocket) halt
  sockread %dn_temp
  tokenize 215 %dn_temp
  unset %dn_temp
  if ($3) {
    if ($dialog(dumanet_uzenofal)) {
      did -a dumanet_uzenofal 1 $1 ( $+ $asctime($2,yyyy.mm.dd - HH:nn:ss) $+ ) $+ $crlf
      did -a dumanet_uzenofal 1 $3- $+ $crlf
      did -a dumanet_uzenofal 1 $crlf
      did -c dumanet_uzenofal 1 $did(dumanet_uzenofal,1).lines
    }
    %dumanet_uzenofal_last = $2
  }
}
on 1:sockread:dn_uzenofal_check*:{
  if ($sockerr > 0) halt
  if ($sockname != %dumanet_uzenofal_checksocket) halt
  sockread %dn_temp
  tokenize 215 %dn_temp
  unset %dn_temp
  if ($3) {
    if ($dialog(dumanet_uzenofal)) {
      did -a dumanet_uzenofal 1 $1 ( $+ $asctime($2,yyyy.mm.dd - HH:nn:ss) $+ ) $+ $crlf
      did -a dumanet_uzenofal 1 $3- $+ $crlf
      did -a dumanet_uzenofal 1 $crlf
      did -c dumanet_uzenofal 1 $did(dumanet_uzenofal,1).lines
    }
    if ($svar(3)) flash DumaNet - Új üzenet érkezett a falra!
    if ($svar(4)) && ($version >= 6.31) noop $tip(1,DumaNet - Üzenőfal, $+ $1 $+  ( $+ $asctime($2,HH:nn:ss) $+ ) $+ $crlf $+ $3-,10,,,uzenofal)
    if ($svar(5)) {
      echo -a -
      echo -a $1 új bejegyzést írt a DumaNet üzenőfalra ( $+ $asctime($2,HH:nn:ss) $+ )
      echo -a $3-
      echo -a -    
    }
    %dumanet_uzenofal_last = $2
  }
}
